#!/usr/bin/python
# -*- encoding: utf8 -*-

import sys
sys.path.append ("/usr/lib")

import logging

from optparse        import OptionParser
from nedm_daq_server import *


if __name__ == '__main__':

  usage = """
             %prog <options>
             %prog -h
          """

  parser = OptionParser(usage=usage)
  parser.add_option('--server_ip',
                    action='store',
                    type='string',
                    dest='ip',
                    default="129.129.141.48",
                    help="Server IP address. [%default]")
  parser.add_option('--server_port',
                    action='store',
                    type='int',
                    dest='port',
                    default=8888,
                    help="Server port. [%default]")
  parser.add_option('--setup_dir',
                    action='store',
                    type='string',
                    dest='setup_dir',
                    default=".",
                    help="Setup directory (where config_faster.yaml directory is). [%default]")
  parser.add_option('--data_dir',
                    action='store',
                    type='string',
                    dest='data_dir',
                    default=".",
                    help="Data directory (where you put your data). [%default]")
  parser.add_option('--log_file',
                    action='store',
                    type='string',
                    dest='log_file',
                    default=".server_log",
                    help="Logging filename. [%default]")
  parser.add_option('--log_level',
                    action='store',
                    type='string',
                    dest='log_level',
                    default="INFO",
                    help="Logging level [INFO|WARNING|ERROR]. [%default]")
  parser.add_option('--without_hardware',
                    action='store_true',
                    dest='without_hardware',
                    default=False,
                    help="")
  options, args = parser.parse_args()
  parser.print_help ()
  #
  if options.log_level == "WARNING":
    log_level=logging.WARNING
  elif options.log_level == "ERROR":
    log_level=logging.ERROR
  else:
    log_level=logging.INFO
  #

  logging_config (options.log_file, log_level)
  catch_signal_init ()


  server = nEDM_Server (server_address   = (options.ip, options.port),
                        setup_dir        = options.setup_dir,
                        data_dir         = options.data_dir,
                        without_hardware = options.without_hardware)

  logging.info (py_time() + " ################  server begin  ################")

  server.serve_forever ()     ### FOREVER  => send 'stop_server' to finish ###

  print ' nEDM FASTER SERVER CLOSED'

  logging.info (py_time() + " ################   server end   ################")

#


##############################################

